import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import * as wjcXlsx from '@mescius/wijmo.xlsx';
import { getEmployeesWithExpences } from './data';
document.readyState === 'complete' ? init() : window.onload = init;
function init() {
let data = getEmployeesWithExpences();
document.querySelector('#saveExpense').addEventListener('click', () => {
let workbook = _exportExpenseReport(data);
workbook.saveAsync('ExpenseReport.xlsx');
});
function _exportExpenseReport(employees) {
var book = new wjcXlsx.Workbook();
var dateFormat = wjcXlsx.Workbook.toXlsxDateFormat('d'), stdNumWidth = 85, simpleCaptionStyle = new wjcXlsx.WorkbookStyle(), accentCaptionStyle = new wjcXlsx.WorkbookStyle(), totalCaptionStyle = new wjcXlsx.WorkbookStyle(), valueStyle = new wjcXlsx.WorkbookStyle(), highlightedValueStyle = new wjcXlsx.WorkbookStyle(), tableHeaderStyle = new wjcXlsx.WorkbookStyle(), tableFooterCurrencyStyle = new wjcXlsx.WorkbookStyle(), tableValueStyle = new wjcXlsx.WorkbookStyle(), tableDateStyle = new wjcXlsx.WorkbookStyle(), tableCurrencyStyle = new wjcXlsx.WorkbookStyle(), tableIntegerStyle = new wjcXlsx.WorkbookStyle();
simpleCaptionStyle.hAlign = wjcXlsx.HAlign.Right;
accentCaptionStyle.font = new wjcXlsx.WorkbookFont();
accentCaptionStyle.font.color = '#808097';
totalCaptionStyle.basedOn = simpleCaptionStyle;
totalCaptionStyle.font = new wjcXlsx.WorkbookFont();
totalCaptionStyle.font.bold = true;
totalCaptionStyle.hAlign = wjcXlsx.HAlign.Right;
valueStyle.font = new wjcXlsx.WorkbookFont();
valueStyle.font.family = 'Arial';
highlightedValueStyle.basedOn = valueStyle;
highlightedValueStyle.fill = new wjcXlsx.WorkbookFill();
highlightedValueStyle.fill.color = '#e1e1e1';
tableHeaderStyle.font = new wjcXlsx.WorkbookFont();
tableHeaderStyle.font.bold = true;
tableHeaderStyle.fill = new wjcXlsx.WorkbookFill();
tableHeaderStyle.fill.color = '#fad9cd';
tableFooterCurrencyStyle.basedOn = tableHeaderStyle;
tableFooterCurrencyStyle.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
tableFooterCurrencyStyle.hAlign = wjcXlsx.HAlign.Right;
tableValueStyle.fill = new wjcXlsx.WorkbookFill();
tableValueStyle.fill.color = '#f4b19b';
tableDateStyle.basedOn = tableValueStyle;
tableCurrencyStyle.basedOn = tableValueStyle;
tableCurrencyStyle.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
tableIntegerStyle.basedOn = tableValueStyle;
tableIntegerStyle.format = wjcXlsx.Workbook.toXlsxNumberFormat('00');
for (var emplIdx = 0; emplIdx < employees.length; emplIdx++) {
var empl = employees[emplIdx], sheet = new wjcXlsx.WorkSheet(), rows = sheet.rows;
book.sheets.push(sheet);
sheet.name = empl.Name;
sheet.columns[0] = new wjcXlsx.WorkbookColumn();
sheet.columns[0].width = '1ch';
sheet.columns[1] = new wjcXlsx.WorkbookColumn();
sheet.columns[1].width = 100;
sheet.columns[2] = new wjcXlsx.WorkbookColumn();
sheet.columns[2].width = 200;
sheet.columns[3] = new wjcXlsx.WorkbookColumn();
sheet.columns[3].width = stdNumWidth;
sheet.columns[4] = new wjcXlsx.WorkbookColumn();
sheet.columns[4].width = stdNumWidth;
sheet.columns[6] = new wjcXlsx.WorkbookColumn();
sheet.columns[6].width = stdNumWidth;
sheet.columns[7] = new wjcXlsx.WorkbookColumn();
sheet.columns[7].width = stdNumWidth;
sheet.columns[8] = new wjcXlsx.WorkbookColumn();
sheet.columns[8].width = 130;
sheet.columns[9] = new wjcXlsx.WorkbookColumn();
sheet.columns[9].width = 130;
sheet.columns[10] = new wjcXlsx.WorkbookColumn();
sheet.columns[10].width = stdNumWidth;
//============= Report header - Employee data =========================
rows[0] = new wjcXlsx.WorkbookRow();
rows[0].cells[8] = new wjcXlsx.WorkbookCell();
rows[0].cells[8].colSpan = 3;
rows[0].cells[8].value = 'For Office Use Only';
rows[0].cells[8].style = new wjcXlsx.WorkbookStyle();
rows[0].cells[8].style.basedOn = highlightedValueStyle;
rows[0].cells[8].style.font = new wjcXlsx.WorkbookFont();
rows[0].cells[8].style.font.italic = true;
rows[1] = new wjcXlsx.WorkbookRow();
rows[1].height = 45;
rows[1].cells[1] = new wjcXlsx.WorkbookCell();
rows[1].cells[1].value = 'Expense Report';
rows[1].cells[1].link = 'A1:B1';
rows[1].cells[1].colSpan = 3;
rows[1].cells[1].style = new wjcXlsx.WorkbookStyle();
rows[1].cells[1].style.basedOn = accentCaptionStyle;
rows[1].cells[1].style.font = new wjcXlsx.WorkbookFont();
rows[1].cells[1].style.font.size = 32;
rows[1].cells[1].style.font.bold = true;
rows[2] = new wjcXlsx.WorkbookRow();
rows[2].cells[1] = new wjcXlsx.WorkbookCell();
rows[2].cells[1].value = 'PURPOSE:';
rows[2].cells[1].style = accentCaptionStyle;
rows[2].cells[2] = new wjcXlsx.WorkbookCell();
rows[2].cells[2].value = empl.Purpose;
rows[2].cells[5] = new wjcXlsx.WorkbookCell();
rows[2].cells[5].value = 'Attachment:';
rows[2].cells[5].style = accentCaptionStyle;
rows[2].cells[6] = new wjcXlsx.WorkbookCell();
rows[2].cells[6].value = empl.Attachment;
rows[5] = new wjcXlsx.WorkbookRow();
rows[5].cells[1] = new wjcXlsx.WorkbookCell();
rows[5].cells[1].value = 'EMPLOYEE IMFORMATION:';
rows[5].cells[1].style = accentCaptionStyle;
rows[5].cells[1].colSpan = 2;
rows[6] = new wjcXlsx.WorkbookRow();
rows[6].cells[1] = new wjcXlsx.WorkbookCell();
rows[6].cells[1].value = 'Name';
rows[6].cells[1].link = 'https://cn.bing.com/';
rows[6].cells[1].style = simpleCaptionStyle;
rows[6].cells[2] = new wjcXlsx.WorkbookCell();
rows[6].cells[2].value = empl.Name;
rows[6].cells[5] = new wjcXlsx.WorkbookCell();
rows[6].cells[5].value = 'Position';
rows[6].cells[5].style = simpleCaptionStyle;
rows[6].cells[6] = new wjcXlsx.WorkbookCell();
rows[6].cells[6].value = empl.Position;
rows[6].cells[9] = new wjcXlsx.WorkbookCell();
rows[6].cells[9].value = 'SSN';
rows[6].cells[9].style = simpleCaptionStyle;
rows[6].cells[10] = new wjcXlsx.WorkbookCell();
rows[6].cells[10].value = empl.SSN;
rows[7] = new wjcXlsx.WorkbookRow();
rows[7].cells[1] = new wjcXlsx.WorkbookCell();
rows[7].cells[1].value = 'Department';
rows[7].cells[1].style = simpleCaptionStyle;
rows[7].cells[2] = new wjcXlsx.WorkbookCell();
rows[7].cells[2].value = empl.Department;
rows[7].cells[5] = new wjcXlsx.WorkbookCell();
rows[7].cells[5].value = 'Manager';
rows[7].cells[5].style = simpleCaptionStyle;
rows[7].cells[6] = new wjcXlsx.WorkbookCell();
rows[7].cells[6].value = empl.Manager;
rows[7].cells[9] = new wjcXlsx.WorkbookCell();
rows[7].cells[9].value = 'Employee ID';
rows[7].cells[9].style = simpleCaptionStyle;
rows[7].cells[10] = new wjcXlsx.WorkbookCell();
rows[7].cells[10].value = empl.Id;
//================ Expense items table ==========================
// Table header
rows[9] = new wjcXlsx.WorkbookRow();
rows[9].style = new wjcXlsx.WorkbookStyle();
rows[9].style.hAlign = wjcXlsx.HAlign.Center;
rows[9].cells[1] = new wjcXlsx.WorkbookCell();
rows[9].cells[1].value = 'Date';
rows[9].cells[1].style = tableHeaderStyle;
rows[9].cells[2] = new wjcXlsx.WorkbookCell();
rows[9].cells[2].value = 'Decsription';
rows[9].cells[2].style = tableHeaderStyle;
rows[9].cells[3] = new wjcXlsx.WorkbookCell();
rows[9].cells[3].value = 'Hotel';
rows[9].cells[3].style = tableHeaderStyle;
rows[9].cells[4] = new wjcXlsx.WorkbookCell();
rows[9].cells[4].value = 'Transport';
rows[9].cells[4].style = tableHeaderStyle;
rows[9].cells[5] = new wjcXlsx.WorkbookCell();
rows[9].cells[5].value = 'Fuel';
rows[9].cells[5].style = tableHeaderStyle;
rows[9].cells[6] = new wjcXlsx.WorkbookCell();
rows[9].cells[6].value = 'Meal';
rows[9].cells[6].style = tableHeaderStyle;
rows[9].cells[7] = new wjcXlsx.WorkbookCell();
rows[9].cells[7].value = 'Misc';
rows[9].cells[7].style = tableHeaderStyle;
rows[9].cells[8] = new wjcXlsx.WorkbookCell();
rows[9].cells[8].value = 'Parking (per hour)';
rows[9].cells[8].style = tableHeaderStyle;
rows[9].cells[9] = new wjcXlsx.WorkbookCell();
rows[9].cells[9].value = 'Parking (hours)';
rows[9].cells[9].style = tableHeaderStyle;
rows[9].cells[10] = new wjcXlsx.WorkbookCell();
rows[9].cells[10].value = 'Total';
rows[9].cells[10].style = tableHeaderStyle;
// Table items
var expenses = empl.Expenses, firstIdx = 10, totalIdx = firstIdx + expenses.length;
for (var i = 0; i < expenses.length; i++) {
var curExpense = expenses[i], rowIdx = firstIdx + i;
rows[rowIdx] = new wjcXlsx.WorkbookRow();
rows[rowIdx].cells[1] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[1].value = curExpense.Date;
rows[rowIdx].cells[1].style = tableDateStyle;
rows[rowIdx].cells[2] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[2].value = curExpense.Decsription;
rows[rowIdx].cells[2].style = tableCurrencyStyle;
rows[rowIdx].cells[3] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[3].value = curExpense.Hotel;
rows[rowIdx].cells[3].style = tableCurrencyStyle;
rows[rowIdx].cells[4] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[4].value = curExpense.Transport;
rows[rowIdx].cells[4].style = tableCurrencyStyle;
rows[rowIdx].cells[5] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[5].value = curExpense.Fuel;
rows[rowIdx].cells[5].style = tableCurrencyStyle;
rows[rowIdx].cells[6] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[6].value = curExpense.Meal;
rows[rowIdx].cells[6].style = tableCurrencyStyle;
rows[rowIdx].cells[7] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[7].value = curExpense.Misc;
rows[rowIdx].cells[7].style = tableCurrencyStyle;
rows[rowIdx].cells[8] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[8].value = curExpense.ParkingRate;
rows[rowIdx].cells[8].style = tableCurrencyStyle;
rows[rowIdx].cells[9] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[9].value = curExpense.ParkingHours;
rows[rowIdx].cells[9].style = tableIntegerStyle;
rows[rowIdx].cells[10] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[10].formula = 'SUM(' + wjcXlsx.Workbook.xlsxAddress(rowIdx, 3) + ':' + wjcXlsx.Workbook.xlsxAddress(rowIdx, 7) + ')+' +
wjcXlsx.Workbook.xlsxAddress(rowIdx, 8) + '*' + wjcXlsx.Workbook.xlsxAddress(rowIdx, 9);
rows[rowIdx].cells[10].style = tableCurrencyStyle;
}
// Totals row
var totalColumnIndexes = [3, 4, 5, 6, 7, 10];
rows[totalIdx] = new wjcXlsx.WorkbookRow();
rows[totalIdx].cells[1] = new wjcXlsx.WorkbookCell();
rows[totalIdx].cells[1].value = 'Total';
rows[totalIdx].cells[1].style = tableHeaderStyle;
for (var ti in totalColumnIndexes) {
var ci = totalColumnIndexes[ti];
rows[totalIdx].cells[ci] = new wjcXlsx.WorkbookCell();
rows[totalIdx].cells[ci].formula = 'sum(' + wjcXlsx.Workbook.xlsxAddress(firstIdx, ci) + ':' + wjcXlsx.Workbook.xlsxAddress(totalIdx - 1, ci) + ')';
rows[totalIdx].cells[ci].style = tableFooterCurrencyStyle;
}
rows[totalIdx].cells[8] = new wjcXlsx.WorkbookCell();
rows[totalIdx].cells[8].formula = 'SUMPRODUCT(' + wjcXlsx.Workbook.xlsxAddress(firstIdx, 7) + ':' + wjcXlsx.Workbook.xlsxAddress(totalIdx - 1, 7) + ',' +
wjcXlsx.Workbook.xlsxAddress(firstIdx, 8) + ':' + wjcXlsx.Workbook.xlsxAddress(totalIdx - 1, 8) + ')';
rows[totalIdx].cells[8].colSpan = 2;
rows[totalIdx].cells[8].style = tableFooterCurrencyStyle;
rows[totalIdx].cells[2] = new wjcXlsx.WorkbookCell();
rows[totalIdx].cells[2].style = tableHeaderStyle;
// From/To dates in header, via MAX/MIN formulas on Date field
rows[2].cells[8] = new wjcXlsx.WorkbookCell();
rows[2].cells[8].value = 'PAY PERIOD:';
rows[2].cells[8].style = accentCaptionStyle;
rows[2].cells[9] = new wjcXlsx.WorkbookCell();
rows[2].cells[9].value = 'From';
rows[2].cells[9].style = simpleCaptionStyle;
var datesRange = wjcXlsx.Workbook.xlsxAddress(firstIdx, 1, true) + ':' + wjcXlsx.Workbook.xlsxAddress(totalIdx - 1, 1, true);
rows[2].cells[10] = new wjcXlsx.WorkbookCell();
rows[2].cells[10].formula = 'MIN(' + datesRange + ')';
rows[2].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[2].cells[10].style.format = dateFormat;
rows[3] = new wjcXlsx.WorkbookRow();
rows[3].cells[9] = new wjcXlsx.WorkbookCell();
rows[3].cells[9].value = 'To';
rows[3].cells[9].style = simpleCaptionStyle;
rows[3].cells[10] = new wjcXlsx.WorkbookCell();
rows[3].cells[10].formula = 'MAX(' + datesRange + ')';
rows[3].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[3].cells[10].style.format = dateFormat;
//============ Report footer - totals and misc fields
var footerIdx = totalIdx + 1;
rows[footerIdx] = new wjcXlsx.WorkbookRow();
rows[footerIdx].cells[9] = new wjcXlsx.WorkbookCell();
rows[footerIdx].cells[9].value = 'Subtotal';
rows[footerIdx].cells[9].style = totalCaptionStyle;
rows[footerIdx].cells[10] = new wjcXlsx.WorkbookCell();
rows[footerIdx].cells[10].formula = wjcXlsx.Workbook.xlsxAddress(footerIdx + 2, 10) + '-' + wjcXlsx.Workbook.xlsxAddress(footerIdx + 1, 10);
rows[footerIdx].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[footerIdx].cells[10].style.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
rows[footerIdx + 1] = new wjcXlsx.WorkbookRow();
rows[footerIdx + 1].cells[9] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 1].cells[9].value = 'Cash Advance';
rows[footerIdx + 1].cells[9].style = totalCaptionStyle;
rows[footerIdx + 1].cells[10] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 1].cells[10].value = empl.Advance;
rows[footerIdx + 1].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[footerIdx + 1].cells[10].style.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
rows[footerIdx + 2] = new wjcXlsx.WorkbookRow();
rows[footerIdx + 2].cells[9] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 2].cells[9].value = 'Total';
rows[footerIdx + 2].cells[9].style = totalCaptionStyle;
rows[footerIdx + 2].cells[10] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 2].cells[10].formula = wjcXlsx.Workbook.xlsxAddress(totalIdx, 10);
rows[footerIdx + 2].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[footerIdx + 2].cells[10].style.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
rows[footerIdx + 3] = new wjcXlsx.WorkbookRow();
rows[footerIdx + 3].cells[1] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 3].cells[1].value = 'APPROVED:';
rows[footerIdx + 3].cells[1].style = accentCaptionStyle;
rows[footerIdx + 3].cells[4] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 3].cells[4].value = 'NOTES:';
rows[footerIdx + 3].cells[4].style = accentCaptionStyle;
}
return book;
}
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Expense Report Export</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div class="container-fluid">
<!-- the flex grid -->
<div class="row">
<button id="saveExpense" class="btn btn-default">Save Report</button>
</div>
</div>
</body>
</html>
export function getEmployeesWithExpences() {
return [
{
Id: 'E892659',
Name: 'Robert King',
Department: 'Sales',
Position: 'Sales Representative',
SSN: 'A37830',
Manager: 'Andrew Fuller',
Purpose: 'On business',
Attachment: true,
Advance: 1000,
Expenses: _getExpenseItems()
},
{
Id: 'E3667093',
Name: 'John Taylor',
Department: 'Sales',
Position: 'Sales Representative',
SSN: 'A83745',
Manager: 'Andrew Fuller',
Purpose: 'On business',
Attachment: false,
Advance: 800,
Expenses: _getExpenseItems()
},
{
Id: 'E294989',
Name: 'Gregory Allen',
Department: 'Sales',
Position: 'Sales Representative',
SSN: 'A23927',
Manager: 'Andrew Fuller',
Purpose: 'On business',
Attachment: true,
Advance: 1200,
Expenses: _getExpenseItems()
},
];
}
function _getExpenseItems() {
let count = 5 + Math.round(Math.random() * 5), ret = [], msPerDay = 1000 * 24 * 60 * 60, curDate = Date.now() - 60 * msPerDay;
for (let i = 0; i < count; i++) {
ret.push({
Date: new Date(curDate),
Decsription: 'Customer visit',
Hotel: 30 + Math.random() * 200,
Transport: 10 + Math.random() * 150,
Fuel: Math.random() * 50,
Meal: 30 + Math.random() * 170,
ParkingRate: 3.75,
ParkingHours: 8 + Math.round(Math.random() * 16),
Misc: Math.random() * 220
});
curDate += msPerDay * Math.round(Math.random() * 4);
}
return ret;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

import 'bootstrap.css';
import '@grapecity/wijmo.styles/wijmo.css';
import * as React from 'react';
import * as ReactDOM from 'react-dom/client';
import * as wjcXlsx from '@grapecity/wijmo.xlsx';
import { getEmployeesWithExpences } from './data';
class App extends React.Component {
constructor(props) {
super(props);
this.state = {
data: getEmployeesWithExpences()
};
}
render() {
return <div className="container-fluid">
<div className="row">
<button onClick={this.saveExpenses.bind(this)} className="btn btn-default">Save Report</button>
</div>
</div>;
}
saveExpenses() {
let workbook = this._exportExpenseReport(this.state.data);
workbook.saveAsync('ExpenseReport.xlsx');
}
_exportExpenseReport(employees) {
var book = new wjcXlsx.Workbook();
var dateFormat = wjcXlsx.Workbook.toXlsxDateFormat('d'), stdNumWidth = 85, simpleCaptionStyle = new wjcXlsx.WorkbookStyle(), accentCaptionStyle = new wjcXlsx.WorkbookStyle(), totalCaptionStyle = new wjcXlsx.WorkbookStyle(), valueStyle = new wjcXlsx.WorkbookStyle(), highlightedValueStyle = new wjcXlsx.WorkbookStyle(), tableHeaderStyle = new wjcXlsx.WorkbookStyle(), tableFooterCurrencyStyle = new wjcXlsx.WorkbookStyle(), tableValueStyle = new wjcXlsx.WorkbookStyle(), tableDateStyle = new wjcXlsx.WorkbookStyle(), tableCurrencyStyle = new wjcXlsx.WorkbookStyle(), tableIntegerStyle = new wjcXlsx.WorkbookStyle();
simpleCaptionStyle.hAlign = wjcXlsx.HAlign.Right;
accentCaptionStyle.font = new wjcXlsx.WorkbookFont();
accentCaptionStyle.font.color = '#808097';
totalCaptionStyle.basedOn = simpleCaptionStyle;
totalCaptionStyle.font = new wjcXlsx.WorkbookFont();
totalCaptionStyle.font.bold = true;
totalCaptionStyle.hAlign = wjcXlsx.HAlign.Right;
valueStyle.font = new wjcXlsx.WorkbookFont();
valueStyle.font.family = 'Arial';
highlightedValueStyle.basedOn = valueStyle;
highlightedValueStyle.fill = new wjcXlsx.WorkbookFill();
highlightedValueStyle.fill.color = '#e1e1e1';
tableHeaderStyle.font = new wjcXlsx.WorkbookFont();
tableHeaderStyle.font.bold = true;
tableHeaderStyle.fill = new wjcXlsx.WorkbookFill();
tableHeaderStyle.fill.color = '#fad9cd';
tableFooterCurrencyStyle.basedOn = tableHeaderStyle;
tableFooterCurrencyStyle.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
tableFooterCurrencyStyle.hAlign = wjcXlsx.HAlign.Right;
tableValueStyle.fill = new wjcXlsx.WorkbookFill();
tableValueStyle.fill.color = '#f4b19b';
tableDateStyle.basedOn = tableValueStyle;
tableCurrencyStyle.basedOn = tableValueStyle;
tableCurrencyStyle.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
tableIntegerStyle.basedOn = tableValueStyle;
tableIntegerStyle.format = wjcXlsx.Workbook.toXlsxNumberFormat('00');
for (var emplIdx = 0; emplIdx < employees.length; emplIdx++) {
var empl = employees[emplIdx], sheet = new wjcXlsx.WorkSheet(), rows = sheet.rows;
book.sheets.push(sheet);
sheet.name = empl.Name;
sheet.columns[0] = new wjcXlsx.WorkbookColumn();
sheet.columns[0].width = '1ch';
sheet.columns[1] = new wjcXlsx.WorkbookColumn();
sheet.columns[1].width = 100;
sheet.columns[2] = new wjcXlsx.WorkbookColumn();
sheet.columns[2].width = 200;
sheet.columns[3] = new wjcXlsx.WorkbookColumn();
sheet.columns[3].width = stdNumWidth;
sheet.columns[4] = new wjcXlsx.WorkbookColumn();
sheet.columns[4].width = stdNumWidth;
sheet.columns[6] = new wjcXlsx.WorkbookColumn();
sheet.columns[6].width = stdNumWidth;
sheet.columns[7] = new wjcXlsx.WorkbookColumn();
sheet.columns[7].width = stdNumWidth;
sheet.columns[8] = new wjcXlsx.WorkbookColumn();
sheet.columns[8].width = 130;
sheet.columns[9] = new wjcXlsx.WorkbookColumn();
sheet.columns[9].width = 130;
sheet.columns[10] = new wjcXlsx.WorkbookColumn();
sheet.columns[10].width = stdNumWidth;
//============= Report header - Employee data =========================
rows[0] = new wjcXlsx.WorkbookRow();
rows[0].cells[8] = new wjcXlsx.WorkbookCell();
rows[0].cells[8].colSpan = 3;
rows[0].cells[8].value = 'For Office Use Only';
rows[0].cells[8].style = new wjcXlsx.WorkbookStyle();
rows[0].cells[8].style.basedOn = highlightedValueStyle;
rows[0].cells[8].style.font = new wjcXlsx.WorkbookFont();
rows[0].cells[8].style.font.italic = true;
rows[1] = new wjcXlsx.WorkbookRow();
rows[1].height = 45;
rows[1].cells[1] = new wjcXlsx.WorkbookCell();
rows[1].cells[1].value = 'Expense Report';
rows[1].cells[1].link = 'A1:B1';
rows[1].cells[1].colSpan = 3;
rows[1].cells[1].style = new wjcXlsx.WorkbookStyle();
rows[1].cells[1].style.basedOn = accentCaptionStyle;
rows[1].cells[1].style.font = new wjcXlsx.WorkbookFont();
rows[1].cells[1].style.font.size = 32;
rows[1].cells[1].style.font.bold = true;
rows[2] = new wjcXlsx.WorkbookRow();
rows[2].cells[1] = new wjcXlsx.WorkbookCell();
rows[2].cells[1].value = 'PURPOSE:';
rows[2].cells[1].style = accentCaptionStyle;
rows[2].cells[2] = new wjcXlsx.WorkbookCell();
rows[2].cells[2].value = empl.Purpose;
rows[2].cells[5] = new wjcXlsx.WorkbookCell();
rows[2].cells[5].value = 'Attachment:';
rows[2].cells[5].style = accentCaptionStyle;
rows[2].cells[6] = new wjcXlsx.WorkbookCell();
rows[2].cells[6].value = empl.Attachment;
rows[5] = new wjcXlsx.WorkbookRow();
rows[5].cells[1] = new wjcXlsx.WorkbookCell();
rows[5].cells[1].value = 'EMPLOYEE IMFORMATION:';
rows[5].cells[1].style = accentCaptionStyle;
rows[5].cells[1].colSpan = 2;
rows[6] = new wjcXlsx.WorkbookRow();
rows[6].cells[1] = new wjcXlsx.WorkbookCell();
rows[6].cells[1].value = 'Name';
rows[6].cells[1].link = 'https://cn.bing.com/';
rows[6].cells[1].style = simpleCaptionStyle;
rows[6].cells[2] = new wjcXlsx.WorkbookCell();
rows[6].cells[2].value = empl.Name;
rows[6].cells[5] = new wjcXlsx.WorkbookCell();
rows[6].cells[5].value = 'Position';
rows[6].cells[5].style = simpleCaptionStyle;
rows[6].cells[6] = new wjcXlsx.WorkbookCell();
rows[6].cells[6].value = empl.Position;
rows[6].cells[9] = new wjcXlsx.WorkbookCell();
rows[6].cells[9].value = 'SSN';
rows[6].cells[9].style = simpleCaptionStyle;
rows[6].cells[10] = new wjcXlsx.WorkbookCell();
rows[6].cells[10].value = empl.SSN;
rows[7] = new wjcXlsx.WorkbookRow();
rows[7].cells[1] = new wjcXlsx.WorkbookCell();
rows[7].cells[1].value = 'Department';
rows[7].cells[1].style = simpleCaptionStyle;
rows[7].cells[2] = new wjcXlsx.WorkbookCell();
rows[7].cells[2].value = empl.Department;
rows[7].cells[5] = new wjcXlsx.WorkbookCell();
rows[7].cells[5].value = 'Manager';
rows[7].cells[5].style = simpleCaptionStyle;
rows[7].cells[6] = new wjcXlsx.WorkbookCell();
rows[7].cells[6].value = empl.Manager;
rows[7].cells[9] = new wjcXlsx.WorkbookCell();
rows[7].cells[9].value = 'Employee ID';
rows[7].cells[9].style = simpleCaptionStyle;
rows[7].cells[10] = new wjcXlsx.WorkbookCell();
rows[7].cells[10].value = empl.Id;
//================ Expense items table ==========================
// Table header
rows[9] = new wjcXlsx.WorkbookRow();
rows[9].style = new wjcXlsx.WorkbookStyle();
rows[9].style.hAlign = wjcXlsx.HAlign.Center;
rows[9].cells[1] = new wjcXlsx.WorkbookCell();
rows[9].cells[1].value = 'Date';
rows[9].cells[1].style = tableHeaderStyle;
rows[9].cells[2] = new wjcXlsx.WorkbookCell();
rows[9].cells[2].value = 'Decsription';
rows[9].cells[2].style = tableHeaderStyle;
rows[9].cells[3] = new wjcXlsx.WorkbookCell();
rows[9].cells[3].value = 'Hotel';
rows[9].cells[3].style = tableHeaderStyle;
rows[9].cells[4] = new wjcXlsx.WorkbookCell();
rows[9].cells[4].value = 'Transport';
rows[9].cells[4].style = tableHeaderStyle;
rows[9].cells[5] = new wjcXlsx.WorkbookCell();
rows[9].cells[5].value = 'Fuel';
rows[9].cells[5].style = tableHeaderStyle;
rows[9].cells[6] = new wjcXlsx.WorkbookCell();
rows[9].cells[6].value = 'Meal';
rows[9].cells[6].style = tableHeaderStyle;
rows[9].cells[7] = new wjcXlsx.WorkbookCell();
rows[9].cells[7].value = 'Misc';
rows[9].cells[7].style = tableHeaderStyle;
rows[9].cells[8] = new wjcXlsx.WorkbookCell();
rows[9].cells[8].value = 'Parking (per hour)';
rows[9].cells[8].style = tableHeaderStyle;
rows[9].cells[9] = new wjcXlsx.WorkbookCell();
rows[9].cells[9].value = 'Parking (hours)';
rows[9].cells[9].style = tableHeaderStyle;
rows[9].cells[10] = new wjcXlsx.WorkbookCell();
rows[9].cells[10].value = 'Total';
rows[9].cells[10].style = tableHeaderStyle;
// Table items
var expenses = empl.Expenses, firstIdx = 10, totalIdx = firstIdx + expenses.length;
for (var i = 0; i < expenses.length; i++) {
var curExpense = expenses[i], rowIdx = firstIdx + i;
rows[rowIdx] = new wjcXlsx.WorkbookRow();
rows[rowIdx].cells[1] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[1].value = curExpense.Date;
rows[rowIdx].cells[1].style = tableDateStyle;
rows[rowIdx].cells[2] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[2].value = curExpense.Decsription;
rows[rowIdx].cells[2].style = tableCurrencyStyle;
rows[rowIdx].cells[3] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[3].value = curExpense.Hotel;
rows[rowIdx].cells[3].style = tableCurrencyStyle;
rows[rowIdx].cells[4] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[4].value = curExpense.Transport;
rows[rowIdx].cells[4].style = tableCurrencyStyle;
rows[rowIdx].cells[5] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[5].value = curExpense.Fuel;
rows[rowIdx].cells[5].style = tableCurrencyStyle;
rows[rowIdx].cells[6] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[6].value = curExpense.Meal;
rows[rowIdx].cells[6].style = tableCurrencyStyle;
rows[rowIdx].cells[7] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[7].value = curExpense.Misc;
rows[rowIdx].cells[7].style = tableCurrencyStyle;
rows[rowIdx].cells[8] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[8].value = curExpense.ParkingRate;
rows[rowIdx].cells[8].style = tableCurrencyStyle;
rows[rowIdx].cells[9] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[9].value = curExpense.ParkingHours;
rows[rowIdx].cells[9].style = tableIntegerStyle;
rows[rowIdx].cells[10] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[10].formula = 'SUM(' + wjcXlsx.Workbook.xlsxAddress(rowIdx, 3) + ':' + wjcXlsx.Workbook.xlsxAddress(rowIdx, 7) + ')+' +
wjcXlsx.Workbook.xlsxAddress(rowIdx, 8) + '*' + wjcXlsx.Workbook.xlsxAddress(rowIdx, 9);
rows[rowIdx].cells[10].style = tableCurrencyStyle;
}
// Totals row
var totalColumnIndexes = [3, 4, 5, 6, 7, 10];
rows[totalIdx] = new wjcXlsx.WorkbookRow();
rows[totalIdx].cells[1] = new wjcXlsx.WorkbookCell();
rows[totalIdx].cells[1].value = 'Total';
rows[totalIdx].cells[1].style = tableHeaderStyle;
for (var ti in totalColumnIndexes) {
var ci = totalColumnIndexes[ti];
rows[totalIdx].cells[ci] = new wjcXlsx.WorkbookCell();
rows[totalIdx].cells[ci].formula = 'sum(' + wjcXlsx.Workbook.xlsxAddress(firstIdx, ci) + ':' + wjcXlsx.Workbook.xlsxAddress(totalIdx - 1, ci) + ')';
rows[totalIdx].cells[ci].style = tableFooterCurrencyStyle;
}
rows[totalIdx].cells[8] = new wjcXlsx.WorkbookCell();
rows[totalIdx].cells[8].formula = 'SUMPRODUCT(' + wjcXlsx.Workbook.xlsxAddress(firstIdx, 7) + ':' + wjcXlsx.Workbook.xlsxAddress(totalIdx - 1, 7) + ',' +
wjcXlsx.Workbook.xlsxAddress(firstIdx, 8) + ':' + wjcXlsx.Workbook.xlsxAddress(totalIdx - 1, 8) + ')';
rows[totalIdx].cells[8].colSpan = 2;
rows[totalIdx].cells[8].style = tableFooterCurrencyStyle;
rows[totalIdx].cells[2] = new wjcXlsx.WorkbookCell();
rows[totalIdx].cells[2].style = tableHeaderStyle;
// From/To dates in header, via MAX/MIN formulas on Date field
rows[2].cells[8] = new wjcXlsx.WorkbookCell();
rows[2].cells[8].value = 'PAY PERIOD:';
rows[2].cells[8].style = accentCaptionStyle;
rows[2].cells[9] = new wjcXlsx.WorkbookCell();
rows[2].cells[9].value = 'From';
rows[2].cells[9].style = simpleCaptionStyle;
var datesRange = wjcXlsx.Workbook.xlsxAddress(firstIdx, 1, true) + ':' + wjcXlsx.Workbook.xlsxAddress(totalIdx - 1, 1, true);
rows[2].cells[10] = new wjcXlsx.WorkbookCell();
rows[2].cells[10].formula = 'MIN(' + datesRange + ')';
rows[2].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[2].cells[10].style.format = dateFormat;
rows[3] = new wjcXlsx.WorkbookRow();
rows[3].cells[9] = new wjcXlsx.WorkbookCell();
rows[3].cells[9].value = 'To';
rows[3].cells[9].style = simpleCaptionStyle;
rows[3].cells[10] = new wjcXlsx.WorkbookCell();
rows[3].cells[10].formula = 'MAX(' + datesRange + ')';
rows[3].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[3].cells[10].style.format = dateFormat;
//============ Report footer - totals and misc fields
var footerIdx = totalIdx + 1;
rows[footerIdx] = new wjcXlsx.WorkbookRow();
rows[footerIdx].cells[9] = new wjcXlsx.WorkbookCell();
rows[footerIdx].cells[9].value = 'Subtotal';
rows[footerIdx].cells[9].style = totalCaptionStyle;
rows[footerIdx].cells[10] = new wjcXlsx.WorkbookCell();
rows[footerIdx].cells[10].formula = wjcXlsx.Workbook.xlsxAddress(footerIdx + 2, 10) + '-' + wjcXlsx.Workbook.xlsxAddress(footerIdx + 1, 10);
rows[footerIdx].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[footerIdx].cells[10].style.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
rows[footerIdx + 1] = new wjcXlsx.WorkbookRow();
rows[footerIdx + 1].cells[9] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 1].cells[9].value = 'Cash Advance';
rows[footerIdx + 1].cells[9].style = totalCaptionStyle;
rows[footerIdx + 1].cells[10] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 1].cells[10].value = empl.Advance;
rows[footerIdx + 1].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[footerIdx + 1].cells[10].style.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
rows[footerIdx + 2] = new wjcXlsx.WorkbookRow();
rows[footerIdx + 2].cells[9] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 2].cells[9].value = 'Total';
rows[footerIdx + 2].cells[9].style = totalCaptionStyle;
rows[footerIdx + 2].cells[10] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 2].cells[10].formula = wjcXlsx.Workbook.xlsxAddress(totalIdx, 10);
rows[footerIdx + 2].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[footerIdx + 2].cells[10].style.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
rows[footerIdx + 3] = new wjcXlsx.WorkbookRow();
rows[footerIdx + 3].cells[1] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 3].cells[1].value = 'APPROVED:';
rows[footerIdx + 3].cells[1].style = accentCaptionStyle;
rows[footerIdx + 3].cells[4] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 3].cells[4].value = 'NOTES:';
rows[footerIdx + 3].cells[4].style = accentCaptionStyle;
}
return book;
}
}
setTimeout(() => {
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
}, 100);
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Expense Report Export</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
export function getEmployeesWithExpences() {
return [
{
Id: 'E892659',
Name: 'Robert King',
Department: 'Sales',
Position: 'Sales Representative',
SSN: 'A37830',
Manager: 'Andrew Fuller',
Purpose: 'On business',
Attachment: true,
Advance: 1000,
Expenses: _getExpenseItems()
},
{
Id: 'E3667093',
Name: 'John Taylor',
Department: 'Sales',
Position: 'Sales Representative',
SSN: 'A83745',
Manager: 'Andrew Fuller',
Purpose: 'On business',
Attachment: false,
Advance: 800,
Expenses: _getExpenseItems()
},
{
Id: 'E294989',
Name: 'Gregory Allen',
Department: 'Sales',
Position: 'Sales Representative',
SSN: 'A23927',
Manager: 'Andrew Fuller',
Purpose: 'On business',
Attachment: true,
Advance: 1200,
Expenses: _getExpenseItems()
},
];
}
function _getExpenseItems() {
let count = 5 + Math.round(Math.random() * 5), ret = [], msPerDay = 1000 * 24 * 60 * 60, curDate = Date.now() - 60 * msPerDay;
for (let i = 0; i < count; i++) {
ret.push({
Date: new Date(curDate),
Decsription: 'Customer visit',
Hotel: 30 + Math.random() * 200,
Transport: 10 + Math.random() * 150,
Fuel: Math.random() * 50,
Meal: 30 + Math.random() * 170,
ParkingRate: 3.75,
ParkingHours: 8 + Math.round(Math.random() * 16),
Misc: Math.random() * 220
});
curDate += msPerDay * Math.round(Math.random() * 4);
}
return ret;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@grapecity/wijmo': 'npm:@grapecity/wijmo/index.js',
'@grapecity/wijmo.input': 'npm:@grapecity/wijmo.input/index.js',
'@grapecity/wijmo.styles': 'npm:@grapecity/wijmo.styles',
'@grapecity/wijmo.cultures': 'npm:@grapecity/wijmo.cultures',
'@grapecity/wijmo.chart': 'npm:@grapecity/wijmo.chart/index.js',
'@grapecity/wijmo.chart.analytics': 'npm:@grapecity/wijmo.chart.analytics/index.js',
'@grapecity/wijmo.chart.animation': 'npm:@grapecity/wijmo.chart.animation/index.js',
'@grapecity/wijmo.chart.annotation': 'npm:@grapecity/wijmo.chart.annotation/index.js',
'@grapecity/wijmo.chart.finance': 'npm:@grapecity/wijmo.chart.finance/index.js',
'@grapecity/wijmo.chart.finance.analytics': 'npm:@grapecity/wijmo.chart.finance.analytics/index.js',
'@grapecity/wijmo.chart.hierarchical': 'npm:@grapecity/wijmo.chart.hierarchical/index.js',
'@grapecity/wijmo.chart.interaction': 'npm:@grapecity/wijmo.chart.interaction/index.js',
'@grapecity/wijmo.chart.radar': 'npm:@grapecity/wijmo.chart.radar/index.js',
'@grapecity/wijmo.chart.render': 'npm:@grapecity/wijmo.chart.render/index.js',
'@grapecity/wijmo.chart.webgl': 'npm:@grapecity/wijmo.chart.webgl/index.js',
'@grapecity/wijmo.chart.map': 'npm:@grapecity/wijmo.chart.map/index.js',
'@grapecity/wijmo.gauge': 'npm:@grapecity/wijmo.gauge/index.js',
'@grapecity/wijmo.grid': 'npm:@grapecity/wijmo.grid/index.js',
'@grapecity/wijmo.grid.detail': 'npm:@grapecity/wijmo.grid.detail/index.js',
'@grapecity/wijmo.grid.filter': 'npm:@grapecity/wijmo.grid.filter/index.js',
'@grapecity/wijmo.grid.search': 'npm:@grapecity/wijmo.grid.search/index.js',
'@grapecity/wijmo.grid.grouppanel': 'npm:@grapecity/wijmo.grid.grouppanel/index.js',
'@grapecity/wijmo.grid.multirow': 'npm:@grapecity/wijmo.grid.multirow/index.js',
'@grapecity/wijmo.grid.transposed': 'npm:@grapecity/wijmo.grid.transposed/index.js',
'@grapecity/wijmo.grid.transposedmultirow': 'npm:@grapecity/wijmo.grid.transposedmultirow/index.js',
'@grapecity/wijmo.grid.pdf': 'npm:@grapecity/wijmo.grid.pdf/index.js',
'@grapecity/wijmo.grid.sheet': 'npm:@grapecity/wijmo.grid.sheet/index.js',
'@grapecity/wijmo.grid.xlsx': 'npm:@grapecity/wijmo.grid.xlsx/index.js',
'@grapecity/wijmo.grid.selector': 'npm:@grapecity/wijmo.grid.selector/index.js',
'@grapecity/wijmo.grid.cellmaker': 'npm:@grapecity/wijmo.grid.cellmaker/index.js',
'@grapecity/wijmo.grid.immutable': 'npm:@grapecity/wijmo.grid.immutable/index.js',
'@grapecity/wijmo.touch': 'npm:@grapecity/wijmo.touch/index.js',
'@grapecity/wijmo.cloud': 'npm:@grapecity/wijmo.cloud/index.js',
'@grapecity/wijmo.nav': 'npm:@grapecity/wijmo.nav/index.js',
'@grapecity/wijmo.odata': 'npm:@grapecity/wijmo.odata/index.js',
'@grapecity/wijmo.olap': 'npm:@grapecity/wijmo.olap/index.js',
'@grapecity/wijmo.rest': 'npm:@grapecity/wijmo.rest/index.js',
'@grapecity/wijmo.pdf': 'npm:@grapecity/wijmo.pdf/index.js',
'@grapecity/wijmo.pdf.security': 'npm:@grapecity/wijmo.pdf.security/index.js',
'@grapecity/wijmo.viewer': 'npm:@grapecity/wijmo.viewer/index.js',
'@grapecity/wijmo.xlsx': 'npm:@grapecity/wijmo.xlsx/index.js',
'@grapecity/wijmo.undo': 'npm:@grapecity/wijmo.undo/index.js',
'@grapecity/wijmo.interop.grid': 'npm:@grapecity/wijmo.interop.grid/index.js',
'@grapecity/wijmo.barcode': 'npm:@grapecity/wijmo.barcode/index.js',
'@grapecity/wijmo.barcode.common': 'npm:@grapecity/wijmo.barcode.common/index.js',
'@grapecity/wijmo.barcode.composite': 'npm:@grapecity/wijmo.barcode.composite/index.js',
'@grapecity/wijmo.barcode.specialized': 'npm:@grapecity/wijmo.barcode.specialized/index.js',
"@grapecity/wijmo.react.chart.analytics": "npm:@grapecity/wijmo.react.chart.analytics/index.js",
"@grapecity/wijmo.react.chart.animation": "npm:@grapecity/wijmo.react.chart.animation/index.js",
"@grapecity/wijmo.react.chart.annotation": "npm:@grapecity/wijmo.react.chart.annotation/index.js",
"@grapecity/wijmo.react.chart.finance.analytics": "npm:@grapecity/wijmo.react.chart.finance.analytics/index.js",
"@grapecity/wijmo.react.chart.finance": "npm:@grapecity/wijmo.react.chart.finance/index.js",
"@grapecity/wijmo.react.chart.hierarchical": "npm:@grapecity/wijmo.react.chart.hierarchical/index.js",
"@grapecity/wijmo.react.chart.interaction": "npm:@grapecity/wijmo.react.chart.interaction/index.js",
"@grapecity/wijmo.react.chart.radar": "npm:@grapecity/wijmo.react.chart.radar/index.js",
"@grapecity/wijmo.react.chart": "npm:@grapecity/wijmo.react.chart/index.js",
"@grapecity/wijmo.react.core": "npm:@grapecity/wijmo.react.core/index.js",
'@grapecity/wijmo.react.chart.map': 'npm:@grapecity/wijmo.react.chart.map/index.js',
"@grapecity/wijmo.react.gauge": "npm:@grapecity/wijmo.react.gauge/index.js",
"@grapecity/wijmo.react.grid.detail": "npm:@grapecity/wijmo.react.grid.detail/index.js",
"@grapecity/wijmo.react.grid.filter": "npm:@grapecity/wijmo.react.grid.filter/index.js",
"@grapecity/wijmo.react.grid.grouppanel": "npm:@grapecity/wijmo.react.grid.grouppanel/index.js",
'@grapecity/wijmo.react.grid.search': 'npm:@grapecity/wijmo.react.grid.search/index.js',
"@grapecity/wijmo.react.grid.multirow": "npm:@grapecity/wijmo.react.grid.multirow/index.js",
"@grapecity/wijmo.react.grid.sheet": "npm:@grapecity/wijmo.react.grid.sheet/index.js",
'@grapecity/wijmo.react.grid.transposed': 'npm:@grapecity/wijmo.react.grid.transposed/index.js',
'@grapecity/wijmo.react.grid.transposedmultirow': 'npm:@grapecity/wijmo.react.grid.transposedmultirow/index.js',
'@grapecity/wijmo.react.grid.immutable': 'npm:@grapecity/wijmo.react.grid.immutable/index.js',
"@grapecity/wijmo.react.grid": "npm:@grapecity/wijmo.react.grid/index.js",
"@grapecity/wijmo.react.input": "npm:@grapecity/wijmo.react.input/index.js",
"@grapecity/wijmo.react.olap": "npm:@grapecity/wijmo.react.olap/index.js",
"@grapecity/wijmo.react.viewer": "npm:@grapecity/wijmo.react.viewer/index.js",
"@grapecity/wijmo.react.nav": "npm:@grapecity/wijmo.react.nav/index.js",
"@grapecity/wijmo.react.base": "npm:@grapecity/wijmo.react.base/index.js",
'@grapecity/wijmo.react.barcode.common': 'npm:@grapecity/wijmo.react.barcode.common/index.js',
'@grapecity/wijmo.react.barcode.composite': 'npm:@grapecity/wijmo.react.barcode.composite/index.js',
'@grapecity/wijmo.react.barcode.specialized': 'npm:@grapecity/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'react-dom/client': 'npm:react-dom/umd/react-dom.production.min.js',
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

<template>
<div class="container-fluid">
<div class="row">
<button v-on:click="saveExpenses()" class="btn btn-default">Save Report</button>
</div>
</div>
</template>
<script>
import "@grapecity/wijmo.styles/wijmo.css";
import 'bootstrap.css';
import Vue from 'vue';
import * as wjcXlsx from '@grapecity/wijmo.xlsx';
import { getEmployeesWithExpences } from "./data";
let App = Vue.extend({
name: "app",
data: function() {
return {
employees: getEmployeesWithExpences()
};
},
methods: {
saveExpenses() {
let workbook = this._exportExpenseReport(this.employees);
workbook.saveAsync('ExpenseReport.xlsx');
},
_exportExpenseReport(employees) {
var book = new wjcXlsx.Workbook();
var dateFormat = wjcXlsx.Workbook.toXlsxDateFormat('d'),
stdNumWidth = 85,
simpleCaptionStyle = new wjcXlsx.WorkbookStyle(),
accentCaptionStyle = new wjcXlsx.WorkbookStyle(),
totalCaptionStyle = new wjcXlsx.WorkbookStyle(),
valueStyle = new wjcXlsx.WorkbookStyle(),
highlightedValueStyle = new wjcXlsx.WorkbookStyle(),
tableHeaderStyle = new wjcXlsx.WorkbookStyle(),
tableFooterCurrencyStyle = new wjcXlsx.WorkbookStyle(),
tableValueStyle = new wjcXlsx.WorkbookStyle(),
tableDateStyle = new wjcXlsx.WorkbookStyle(),
tableCurrencyStyle = new wjcXlsx.WorkbookStyle(),
tableIntegerStyle = new wjcXlsx.WorkbookStyle();
simpleCaptionStyle.hAlign = wjcXlsx.HAlign.Right;
accentCaptionStyle.font = new wjcXlsx.WorkbookFont();
accentCaptionStyle.font.color = '#808097';
totalCaptionStyle.basedOn = simpleCaptionStyle;
totalCaptionStyle.font = new wjcXlsx.WorkbookFont();
totalCaptionStyle.font.bold = true;
totalCaptionStyle.hAlign = wjcXlsx.HAlign.Right;
valueStyle.font = new wjcXlsx.WorkbookFont();
valueStyle.font.family = 'Arial';
highlightedValueStyle.basedOn = valueStyle;
highlightedValueStyle.fill = new wjcXlsx.WorkbookFill();
highlightedValueStyle.fill.color = '#e1e1e1';
tableHeaderStyle.font = new wjcXlsx.WorkbookFont();
tableHeaderStyle.font.bold = true;
tableHeaderStyle.fill = new wjcXlsx.WorkbookFill();
tableHeaderStyle.fill.color = '#fad9cd';
tableFooterCurrencyStyle.basedOn = tableHeaderStyle;
tableFooterCurrencyStyle.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
tableFooterCurrencyStyle.hAlign = wjcXlsx.HAlign.Right;
tableValueStyle.fill = new wjcXlsx.WorkbookFill();
tableValueStyle.fill.color = '#f4b19b';
tableDateStyle.basedOn = tableValueStyle;
tableCurrencyStyle.basedOn = tableValueStyle;
tableCurrencyStyle.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
tableIntegerStyle.basedOn = tableValueStyle;
tableIntegerStyle.format = wjcXlsx.Workbook.toXlsxNumberFormat('00');
for (var emplIdx = 0; emplIdx < employees.length; emplIdx++) {
var empl = employees[emplIdx],
sheet = new wjcXlsx.WorkSheet(),
rows = sheet.rows;
book.sheets.push(sheet);
sheet.name = empl.Name;
sheet.columns[0] = new wjcXlsx.WorkbookColumn();
sheet.columns[0].width = '1ch';
sheet.columns[1] = new wjcXlsx.WorkbookColumn();
sheet.columns[1].width = 100;
sheet.columns[2] = new wjcXlsx.WorkbookColumn();
sheet.columns[2].width = 200;
sheet.columns[3] = new wjcXlsx.WorkbookColumn();
sheet.columns[3].width = stdNumWidth;
sheet.columns[4] = new wjcXlsx.WorkbookColumn();
sheet.columns[4].width = stdNumWidth;
sheet.columns[6] = new wjcXlsx.WorkbookColumn();
sheet.columns[6].width = stdNumWidth;
sheet.columns[7] = new wjcXlsx.WorkbookColumn();
sheet.columns[7].width = stdNumWidth;
sheet.columns[8] = new wjcXlsx.WorkbookColumn();
sheet.columns[8].width = 130;
sheet.columns[9] = new wjcXlsx.WorkbookColumn();
sheet.columns[9].width = 130;
sheet.columns[10] = new wjcXlsx.WorkbookColumn();
sheet.columns[10].width = stdNumWidth;
//============= Report header - Employee data =========================
rows[0] = new wjcXlsx.WorkbookRow();
rows[0].cells[8] = new wjcXlsx.WorkbookCell();
rows[0].cells[8].colSpan = 3;
rows[0].cells[8].value = 'For Office Use Only';
rows[0].cells[8].style = new wjcXlsx.WorkbookStyle();
rows[0].cells[8].style.basedOn = highlightedValueStyle;
rows[0].cells[8].style.font = new wjcXlsx.WorkbookFont();
rows[0].cells[8].style.font.italic = true;
rows[1] = new wjcXlsx.WorkbookRow();
rows[1].height = 45;
rows[1].cells[1] = new wjcXlsx.WorkbookCell();
rows[1].cells[1].value = 'Expense Report';
rows[1].cells[1].link ='A1:B1';
rows[1].cells[1].colSpan = 3;
rows[1].cells[1].style = new wjcXlsx.WorkbookStyle();
rows[1].cells[1].style.basedOn = accentCaptionStyle;
rows[1].cells[1].style.font = new wjcXlsx.WorkbookFont();
rows[1].cells[1].style.font.size = 32;
rows[1].cells[1].style.font.bold = true;
rows[2] = new wjcXlsx.WorkbookRow();
rows[2].cells[1] = new wjcXlsx.WorkbookCell();
rows[2].cells[1].value = 'PURPOSE:';
rows[2].cells[1].style = accentCaptionStyle;
rows[2].cells[2] = new wjcXlsx.WorkbookCell();
rows[2].cells[2].value = empl.Purpose;
rows[2].cells[5] = new wjcXlsx.WorkbookCell();
rows[2].cells[5].value = 'Attachment:';
rows[2].cells[5].style = accentCaptionStyle;
rows[2].cells[6] = new wjcXlsx.WorkbookCell();
rows[2].cells[6].value = empl.Attachment;
rows[5] = new wjcXlsx.WorkbookRow();
rows[5].cells[1] = new wjcXlsx.WorkbookCell();
rows[5].cells[1].value = 'EMPLOYEE IMFORMATION:';
rows[5].cells[1].style = accentCaptionStyle;
rows[5].cells[1].colSpan = 2;
rows[6] = new wjcXlsx.WorkbookRow();
rows[6].cells[1] = new wjcXlsx.WorkbookCell();
rows[6].cells[1].value = 'Name';
rows[6].cells[1].link = 'https://cn.bing.com/';
rows[6].cells[1].style = simpleCaptionStyle;
rows[6].cells[2] = new wjcXlsx.WorkbookCell();
rows[6].cells[2].value = empl.Name;
rows[6].cells[5] = new wjcXlsx.WorkbookCell();
rows[6].cells[5].value = 'Position';
rows[6].cells[5].style = simpleCaptionStyle;
rows[6].cells[6] = new wjcXlsx.WorkbookCell();
rows[6].cells[6].value = empl.Position;
rows[6].cells[9] = new wjcXlsx.WorkbookCell();
rows[6].cells[9].value = 'SSN';
rows[6].cells[9].style = simpleCaptionStyle;
rows[6].cells[10] = new wjcXlsx.WorkbookCell();
rows[6].cells[10].value = empl.SSN;
rows[7] = new wjcXlsx.WorkbookRow();
rows[7].cells[1] = new wjcXlsx.WorkbookCell();
rows[7].cells[1].value = 'Department';
rows[7].cells[1].style = simpleCaptionStyle;
rows[7].cells[2] = new wjcXlsx.WorkbookCell();
rows[7].cells[2].value = empl.Department;
rows[7].cells[5] = new wjcXlsx.WorkbookCell();
rows[7].cells[5].value = 'Manager';
rows[7].cells[5].style = simpleCaptionStyle;
rows[7].cells[6] = new wjcXlsx.WorkbookCell();
rows[7].cells[6].value = empl.Manager;
rows[7].cells[9] = new wjcXlsx.WorkbookCell();
rows[7].cells[9].value = 'Employee ID';
rows[7].cells[9].style = simpleCaptionStyle;
rows[7].cells[10] = new wjcXlsx.WorkbookCell();
rows[7].cells[10].value = empl.Id;
//================ Expense items table ==========================
// Table header
rows[9] = new wjcXlsx.WorkbookRow();
rows[9].style = new wjcXlsx.WorkbookStyle();
rows[9].style.hAlign = wjcXlsx.HAlign.Center;
rows[9].cells[1] = new wjcXlsx.WorkbookCell();
rows[9].cells[1].value = 'Date';
rows[9].cells[1].style = tableHeaderStyle;
rows[9].cells[2] = new wjcXlsx.WorkbookCell();
rows[9].cells[2].value = 'Decsription';
rows[9].cells[2].style = tableHeaderStyle;
rows[9].cells[3] = new wjcXlsx.WorkbookCell();
rows[9].cells[3].value = 'Hotel';
rows[9].cells[3].style = tableHeaderStyle;
rows[9].cells[4] = new wjcXlsx.WorkbookCell();
rows[9].cells[4].value = 'Transport';
rows[9].cells[4].style = tableHeaderStyle;
rows[9].cells[5] = new wjcXlsx.WorkbookCell();
rows[9].cells[5].value = 'Fuel';
rows[9].cells[5].style = tableHeaderStyle;
rows[9].cells[6] = new wjcXlsx.WorkbookCell();
rows[9].cells[6].value = 'Meal';
rows[9].cells[6].style = tableHeaderStyle;
rows[9].cells[7] = new wjcXlsx.WorkbookCell();
rows[9].cells[7].value = 'Misc';
rows[9].cells[7].style = tableHeaderStyle;
rows[9].cells[8] = new wjcXlsx.WorkbookCell();
rows[9].cells[8].value = 'Parking (per hour)';
rows[9].cells[8].style = tableHeaderStyle;
rows[9].cells[9] = new wjcXlsx.WorkbookCell();
rows[9].cells[9].value = 'Parking (hours)';
rows[9].cells[9].style = tableHeaderStyle;
rows[9].cells[10] = new wjcXlsx.WorkbookCell();
rows[9].cells[10].value = 'Total';
rows[9].cells[10].style = tableHeaderStyle;
// Table items
var expenses = empl.Expenses,
firstIdx = 10,
totalIdx = firstIdx + expenses.length;
for (var i = 0; i < expenses.length; i++) {
var curExpense = expenses[i],
rowIdx = firstIdx + i;
rows[rowIdx] = new wjcXlsx.WorkbookRow();
rows[rowIdx].cells[1] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[1].value = curExpense.Date;
rows[rowIdx].cells[1].style = tableDateStyle;
rows[rowIdx].cells[2] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[2].value = curExpense.Decsription;
rows[rowIdx].cells[2].style = tableCurrencyStyle;
rows[rowIdx].cells[3] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[3].value = curExpense.Hotel;
rows[rowIdx].cells[3].style = tableCurrencyStyle;
rows[rowIdx].cells[4] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[4].value = curExpense.Transport;
rows[rowIdx].cells[4].style = tableCurrencyStyle;
rows[rowIdx].cells[5] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[5].value = curExpense.Fuel;
rows[rowIdx].cells[5].style = tableCurrencyStyle;
rows[rowIdx].cells[6] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[6].value = curExpense.Meal;
rows[rowIdx].cells[6].style = tableCurrencyStyle;
rows[rowIdx].cells[7] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[7].value = curExpense.Misc;
rows[rowIdx].cells[7].style = tableCurrencyStyle;
rows[rowIdx].cells[8] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[8].value = curExpense.ParkingRate;
rows[rowIdx].cells[8].style = tableCurrencyStyle;
rows[rowIdx].cells[9] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[9].value = curExpense.ParkingHours;
rows[rowIdx].cells[9].style = tableIntegerStyle;
rows[rowIdx].cells[10] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[10].formula = 'SUM(' + wjcXlsx.Workbook.xlsxAddress(rowIdx, 3) + ':' + wjcXlsx.Workbook.xlsxAddress(rowIdx, 7) + ')+' +
wjcXlsx.Workbook.xlsxAddress(rowIdx, 8) + '*' + wjcXlsx.Workbook.xlsxAddress(rowIdx, 9);
rows[rowIdx].cells[10].style = tableCurrencyStyle;
}
// Totals row
var totalColumnIndexes = [3, 4, 5, 6, 7, 10];
rows[totalIdx] = new wjcXlsx.WorkbookRow();
rows[totalIdx].cells[1] = new wjcXlsx.WorkbookCell();
rows[totalIdx].cells[1].value = 'Total';
rows[totalIdx].cells[1].style = tableHeaderStyle;
for (var ti in totalColumnIndexes) {
var ci = totalColumnIndexes[ti];
rows[totalIdx].cells[ci] = new wjcXlsx.WorkbookCell();
rows[totalIdx].cells[ci].formula = 'sum(' + wjcXlsx.Workbook.xlsxAddress(firstIdx, ci) + ':' + wjcXlsx.Workbook.xlsxAddress(totalIdx - 1, ci) + ')';
rows[totalIdx].cells[ci].style = tableFooterCurrencyStyle;
}
rows[totalIdx].cells[8] = new wjcXlsx.WorkbookCell();
rows[totalIdx].cells[8].formula = 'SUMPRODUCT(' + wjcXlsx.Workbook.xlsxAddress(firstIdx, 7) + ':' + wjcXlsx.Workbook.xlsxAddress(totalIdx - 1, 7) + ',' +
wjcXlsx.Workbook.xlsxAddress(firstIdx, 8) + ':' + wjcXlsx.Workbook.xlsxAddress(totalIdx - 1, 8) + ')';
rows[totalIdx].cells[8].colSpan = 2;
rows[totalIdx].cells[8].style = tableFooterCurrencyStyle;
rows[totalIdx].cells[2] = new wjcXlsx.WorkbookCell();
rows[totalIdx].cells[2].style = tableHeaderStyle;
// From/To dates in header, via MAX/MIN formulas on Date field
rows[2].cells[8] = new wjcXlsx.WorkbookCell();
rows[2].cells[8].value = 'PAY PERIOD:';
rows[2].cells[8].style = accentCaptionStyle;
rows[2].cells[9] = new wjcXlsx.WorkbookCell();
rows[2].cells[9].value = 'From';
rows[2].cells[9].style = simpleCaptionStyle;
var datesRange = wjcXlsx.Workbook.xlsxAddress(firstIdx, 1, true) + ':' + wjcXlsx.Workbook.xlsxAddress(totalIdx - 1, 1, true);
rows[2].cells[10] = new wjcXlsx.WorkbookCell();
rows[2].cells[10].formula = 'MIN(' + datesRange + ')';
rows[2].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[2].cells[10].style.format = dateFormat;
rows[3] = new wjcXlsx.WorkbookRow();
rows[3].cells[9] = new wjcXlsx.WorkbookCell();
rows[3].cells[9].value = 'To';
rows[3].cells[9].style = simpleCaptionStyle;
rows[3].cells[10] = new wjcXlsx.WorkbookCell();
rows[3].cells[10].formula = 'MAX(' + datesRange + ')';
rows[3].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[3].cells[10].style.format = dateFormat;
//============ Report footer - totals and misc fields
var footerIdx = totalIdx + 1;
rows[footerIdx] = new wjcXlsx.WorkbookRow();
rows[footerIdx].cells[9] = new wjcXlsx.WorkbookCell();
rows[footerIdx].cells[9].value = 'Subtotal';
rows[footerIdx].cells[9].style = totalCaptionStyle;
rows[footerIdx].cells[10] = new wjcXlsx.WorkbookCell();
rows[footerIdx].cells[10].formula = wjcXlsx.Workbook.xlsxAddress(footerIdx + 2, 10) + '-' + wjcXlsx.Workbook.xlsxAddress(footerIdx + 1, 10);
rows[footerIdx].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[footerIdx].cells[10].style.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
rows[footerIdx + 1] = new wjcXlsx.WorkbookRow();
rows[footerIdx + 1].cells[9] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 1].cells[9].value = 'Cash Advance';
rows[footerIdx + 1].cells[9].style = totalCaptionStyle;
rows[footerIdx + 1].cells[10] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 1].cells[10].value = empl.Advance;
rows[footerIdx + 1].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[footerIdx + 1].cells[10].style.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
rows[footerIdx + 2] = new wjcXlsx.WorkbookRow();
rows[footerIdx + 2].cells[9] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 2].cells[9].value = 'Total';
rows[footerIdx + 2].cells[9].style = totalCaptionStyle;
rows[footerIdx + 2].cells[10] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 2].cells[10].formula = wjcXlsx.Workbook.xlsxAddress(totalIdx, 10);
rows[footerIdx + 2].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[footerIdx + 2].cells[10].style.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
rows[footerIdx + 3] = new wjcXlsx.WorkbookRow();
rows[footerIdx + 3].cells[1] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 3].cells[1].value = 'APPROVED:';
rows[footerIdx + 3].cells[1].style = accentCaptionStyle;
rows[footerIdx + 3].cells[4] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 3].cells[4].value = 'NOTES:';
rows[footerIdx + 3].cells[4].style = accentCaptionStyle;
}
return book;
}
}
});
new Vue({ render: h => h(App) }).$mount("#app");
</script>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Expense Report Export</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.vue');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
export function getEmployeesWithExpences() {
return [
{
Id: 'E892659',
Name: 'Robert King',
Department: 'Sales',
Position: 'Sales Representative',
SSN: 'A37830',
Manager: 'Andrew Fuller',
Purpose: 'On business',
Attachment: true,
Advance: 1000,
Expenses: _getExpenseItems()
},
{
Id: 'E3667093',
Name: 'John Taylor',
Department: 'Sales',
Position: 'Sales Representative',
SSN: 'A83745',
Manager: 'Andrew Fuller',
Purpose: 'On business',
Attachment: false,
Advance: 800,
Expenses: _getExpenseItems()
},
{
Id: 'E294989',
Name: 'Gregory Allen',
Department: 'Sales',
Position: 'Sales Representative',
SSN: 'A23927',
Manager: 'Andrew Fuller',
Purpose: 'On business',
Attachment: true,
Advance: 1200,
Expenses: _getExpenseItems()
},
];
}
function _getExpenseItems() {
let count = 5 + Math.round(Math.random() * 5),
ret = [],
msPerDay = 1000 * 24 * 60 * 60,
curDate = Date.now() - 60 * msPerDay;
for (let i = 0; i < count; i++) {
ret.push(
{
Date: new Date(curDate),
Decsription: 'Customer visit',
Hotel: 30 + Math.random() * 200,
Transport: 10 + Math.random() * 150,
Fuel: Math.random() * 50,
Meal: 30 + Math.random() * 170,
ParkingRate: 3.75,
ParkingHours: 8 + Math.round(Math.random() * 16),
Misc: Math.random() * 220
});
curDate += msPerDay * Math.round(Math.random() * 4);
}
return ret;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: 'vue-loader' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@grapecity/wijmo': 'npm:@grapecity/wijmo/index.js',
'@grapecity/wijmo.input': 'npm:@grapecity/wijmo.input/index.js',
'@grapecity/wijmo.styles': 'npm:@grapecity/wijmo.styles',
'@grapecity/wijmo.cultures': 'npm:@grapecity/wijmo.cultures',
'@grapecity/wijmo.chart': 'npm:@grapecity/wijmo.chart/index.js',
'@grapecity/wijmo.chart.analytics': 'npm:@grapecity/wijmo.chart.analytics/index.js',
'@grapecity/wijmo.chart.animation': 'npm:@grapecity/wijmo.chart.animation/index.js',
'@grapecity/wijmo.chart.annotation': 'npm:@grapecity/wijmo.chart.annotation/index.js',
'@grapecity/wijmo.chart.finance': 'npm:@grapecity/wijmo.chart.finance/index.js',
'@grapecity/wijmo.chart.finance.analytics': 'npm:@grapecity/wijmo.chart.finance.analytics/index.js',
'@grapecity/wijmo.chart.hierarchical': 'npm:@grapecity/wijmo.chart.hierarchical/index.js',
'@grapecity/wijmo.chart.interaction': 'npm:@grapecity/wijmo.chart.interaction/index.js',
'@grapecity/wijmo.chart.radar': 'npm:@grapecity/wijmo.chart.radar/index.js',
'@grapecity/wijmo.chart.render': 'npm:@grapecity/wijmo.chart.render/index.js',
'@grapecity/wijmo.chart.webgl': 'npm:@grapecity/wijmo.chart.webgl/index.js',
'@grapecity/wijmo.chart.map': 'npm:@grapecity/wijmo.chart.map/index.js',
'@grapecity/wijmo.gauge': 'npm:@grapecity/wijmo.gauge/index.js',
'@grapecity/wijmo.grid': 'npm:@grapecity/wijmo.grid/index.js',
'@grapecity/wijmo.grid.detail': 'npm:@grapecity/wijmo.grid.detail/index.js',
'@grapecity/wijmo.grid.filter': 'npm:@grapecity/wijmo.grid.filter/index.js',
'@grapecity/wijmo.grid.search': 'npm:@grapecity/wijmo.grid.search/index.js',
'@grapecity/wijmo.grid.grouppanel': 'npm:@grapecity/wijmo.grid.grouppanel/index.js',
'@grapecity/wijmo.grid.multirow': 'npm:@grapecity/wijmo.grid.multirow/index.js',
'@grapecity/wijmo.grid.transposed': 'npm:@grapecity/wijmo.grid.transposed/index.js',
'@grapecity/wijmo.grid.transposedmultirow': 'npm:@grapecity/wijmo.grid.transposedmultirow/index.js',
'@grapecity/wijmo.grid.pdf': 'npm:@grapecity/wijmo.grid.pdf/index.js',
'@grapecity/wijmo.grid.sheet': 'npm:@grapecity/wijmo.grid.sheet/index.js',
'@grapecity/wijmo.grid.xlsx': 'npm:@grapecity/wijmo.grid.xlsx/index.js',
'@grapecity/wijmo.grid.selector': 'npm:@grapecity/wijmo.grid.selector/index.js',
'@grapecity/wijmo.grid.cellmaker': 'npm:@grapecity/wijmo.grid.cellmaker/index.js',
'@grapecity/wijmo.nav': 'npm:@grapecity/wijmo.nav/index.js',
'@grapecity/wijmo.odata': 'npm:@grapecity/wijmo.odata/index.js',
'@grapecity/wijmo.olap': 'npm:@grapecity/wijmo.olap/index.js',
'@grapecity/wijmo.rest': 'npm:@grapecity/wijmo.rest/index.js',
'@grapecity/wijmo.pdf': 'npm:@grapecity/wijmo.pdf/index.js',
'@grapecity/wijmo.pdf.security': 'npm:@grapecity/wijmo.pdf.security/index.js',
'@grapecity/wijmo.viewer': 'npm:@grapecity/wijmo.viewer/index.js',
'@grapecity/wijmo.xlsx': 'npm:@grapecity/wijmo.xlsx/index.js',
'@grapecity/wijmo.undo': 'npm:@grapecity/wijmo.undo/index.js',
'@grapecity/wijmo.interop.grid': 'npm:@grapecity/wijmo.interop.grid/index.js',
'@grapecity/wijmo.touch': 'npm:@grapecity/wijmo.touch/index.js',
'@grapecity/wijmo.cloud': 'npm:@grapecity/wijmo.cloud/index.js',
'@grapecity/wijmo.barcode': 'npm:@grapecity/wijmo.barcode/index.js',
'@grapecity/wijmo.barcode.common': 'npm:@grapecity/wijmo.barcode.common/index.js',
'@grapecity/wijmo.barcode.composite': 'npm:@grapecity/wijmo.barcode.composite/index.js',
'@grapecity/wijmo.barcode.specialized': 'npm:@grapecity/wijmo.barcode.specialized/index.js',
"@grapecity/wijmo.vue2.chart.analytics": "npm:@grapecity/wijmo.vue2.chart.analytics/index.js",
"@grapecity/wijmo.vue2.chart.animation": "npm:@grapecity/wijmo.vue2.chart.animation/index.js",
"@grapecity/wijmo.vue2.chart.annotation": "npm:@grapecity/wijmo.vue2.chart.annotation/index.js",
"@grapecity/wijmo.vue2.chart.finance.analytics": "npm:@grapecity/wijmo.vue2.chart.finance.analytics/index.js",
"@grapecity/wijmo.vue2.chart.finance": "npm:@grapecity/wijmo.vue2.chart.finance/index.js",
"@grapecity/wijmo.vue2.chart.hierarchical": "npm:@grapecity/wijmo.vue2.chart.hierarchical/index.js",
"@grapecity/wijmo.vue2.chart.interaction": "npm:@grapecity/wijmo.vue2.chart.interaction/index.js",
"@grapecity/wijmo.vue2.chart.radar": "npm:@grapecity/wijmo.vue2.chart.radar/index.js",
'@grapecity/wijmo.vue2.chart.map': 'npm:@grapecity/wijmo.vue2.chart.map/index.js',
"@grapecity/wijmo.vue2.chart": "npm:@grapecity/wijmo.vue2.chart/index.js",
"@grapecity/wijmo.vue2.core": "npm:@grapecity/wijmo.vue2.core/index.js",
"@grapecity/wijmo.vue2.gauge": "npm:@grapecity/wijmo.vue2.gauge/index.js",
"@grapecity/wijmo.vue2.grid.detail": "npm:@grapecity/wijmo.vue2.grid.detail/index.js",
"@grapecity/wijmo.vue2.grid.filter": "npm:@grapecity/wijmo.vue2.grid.filter/index.js",
"@grapecity/wijmo.vue2.grid.grouppanel": "npm:@grapecity/wijmo.vue2.grid.grouppanel/index.js",
'@grapecity/wijmo.vue2.grid.search': 'npm:@grapecity/wijmo.vue2.grid.search/index.js',
"@grapecity/wijmo.vue2.grid.multirow": "npm:@grapecity/wijmo.vue2.grid.multirow/index.js",
"@grapecity/wijmo.vue2.grid.sheet": "npm:@grapecity/wijmo.vue2.grid.sheet/index.js",
'@grapecity/wijmo.vue2.grid.transposed': 'npm:@grapecity/wijmo.vue2.grid.transposed/index.js',
'@grapecity/wijmo.vue2.grid.transposedmultirow': 'npm:@grapecity/wijmo.vue2.grid.transposedmultirow/index.js',
"@grapecity/wijmo.vue2.grid": "npm:@grapecity/wijmo.vue2.grid/index.js",
"@grapecity/wijmo.vue2.input": "npm:@grapecity/wijmo.vue2.input/index.js",
"@grapecity/wijmo.vue2.olap": "npm:@grapecity/wijmo.vue2.olap/index.js",
"@grapecity/wijmo.vue2.viewer": "npm:@grapecity/wijmo.vue2.viewer/index.js",
"@grapecity/wijmo.vue2.nav": "npm:@grapecity/wijmo.vue2.nav/index.js",
"@grapecity/wijmo.vue2.base": "npm:@grapecity/wijmo.vue2.base/index.js",
'@grapecity/wijmo.vue2.barcode.common': 'npm:@grapecity/wijmo.vue2.barcode.common/index.js',
'@grapecity/wijmo.vue2.barcode.composite': 'npm:@grapecity/wijmo.vue2.barcode.composite/index.js',
'@grapecity/wijmo.vue2.barcode.specialized': 'npm:@grapecity/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.min.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import '@angular/compiler';
import { Component, enableProdMode, Inject, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import * as wjcXlsx from '@mescius/wijmo.xlsx';
import { DataService } from './app.data';
@Component({
standalone: true,
providers: [DataService],
imports: [BrowserModule, FormsModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
private _data: any[];
constructor(@Inject(DataService) dataSvc: DataService) {
this._data = dataSvc.getEmployeesWithExpences();
}
saveExpenses() {
let workbook = this._exportExpenseReport(this._data);
// Set document properties
workbook.title = 'Expense Report';
workbook.subject = 'Employee Expense Report';
workbook.keywords = 'expense, report, finance';
workbook.category = 'Financial Reports';
workbook.saveAsync('ExpenseReport.xlsx');
}
private _exportExpenseReport(employees: any[]): wjcXlsx.Workbook {
var book = new wjcXlsx.Workbook();
var dateFormat = wjcXlsx.Workbook.toXlsxDateFormat('d'),
stdNumWidth = 85,
simpleCaptionStyle = new wjcXlsx.WorkbookStyle(),
accentCaptionStyle = new wjcXlsx.WorkbookStyle(),
totalCaptionStyle = new wjcXlsx.WorkbookStyle(),
valueStyle = new wjcXlsx.WorkbookStyle(),
highlightedValueStyle = new wjcXlsx.WorkbookStyle(),
tableHeaderStyle = new wjcXlsx.WorkbookStyle(),
tableFooterCurrencyStyle = new wjcXlsx.WorkbookStyle(),
tableValueStyle = new wjcXlsx.WorkbookStyle(),
tableDateStyle = new wjcXlsx.WorkbookStyle(),
tableCurrencyStyle = new wjcXlsx.WorkbookStyle(),
tableIntegerStyle = new wjcXlsx.WorkbookStyle();
simpleCaptionStyle.hAlign = wjcXlsx.HAlign.Right;
accentCaptionStyle.font = new wjcXlsx.WorkbookFont();
accentCaptionStyle.font.color = '#808097';
totalCaptionStyle.basedOn = simpleCaptionStyle;
totalCaptionStyle.font = new wjcXlsx.WorkbookFont();
totalCaptionStyle.font.bold = true;
totalCaptionStyle.hAlign = wjcXlsx.HAlign.Right;
valueStyle.font = new wjcXlsx.WorkbookFont();
valueStyle.font.family = 'Arial';
highlightedValueStyle.basedOn = valueStyle;
highlightedValueStyle.fill = new wjcXlsx.WorkbookFill();
highlightedValueStyle.fill.color = '#e1e1e1';
tableHeaderStyle.font = new wjcXlsx.WorkbookFont();
tableHeaderStyle.font.bold = true;
tableHeaderStyle.fill = new wjcXlsx.WorkbookFill();
tableHeaderStyle.fill.color = '#fad9cd';
tableFooterCurrencyStyle.basedOn = tableHeaderStyle;
tableFooterCurrencyStyle.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
tableFooterCurrencyStyle.hAlign = wjcXlsx.HAlign.Right;
tableValueStyle.fill = new wjcXlsx.WorkbookFill();
tableValueStyle.fill.color = '#f4b19b';
tableDateStyle.basedOn = tableValueStyle;
tableCurrencyStyle.basedOn = tableValueStyle;
tableCurrencyStyle.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
tableIntegerStyle.basedOn = tableValueStyle;
tableIntegerStyle.format = wjcXlsx.Workbook.toXlsxNumberFormat('00');
for (var emplIdx = 0; emplIdx < employees.length; emplIdx++) {
var empl = employees[emplIdx],
sheet = new wjcXlsx.WorkSheet(),
rows = sheet.rows;
book.sheets.push(sheet);
sheet.name = empl.Name;
sheet.columns[0] = new wjcXlsx.WorkbookColumn();
sheet.columns[0].width = '1ch';
sheet.columns[1] = new wjcXlsx.WorkbookColumn();
sheet.columns[1].width = 100;
sheet.columns[2] = new wjcXlsx.WorkbookColumn();
sheet.columns[2].width = 200;
sheet.columns[3] = new wjcXlsx.WorkbookColumn();
sheet.columns[3].width = stdNumWidth;
sheet.columns[4] = new wjcXlsx.WorkbookColumn();
sheet.columns[4].width = stdNumWidth;
sheet.columns[6] = new wjcXlsx.WorkbookColumn();
sheet.columns[6].width = stdNumWidth;
sheet.columns[7] = new wjcXlsx.WorkbookColumn();
sheet.columns[7].width = stdNumWidth;
sheet.columns[8] = new wjcXlsx.WorkbookColumn();
sheet.columns[8].width = 130;
sheet.columns[9] = new wjcXlsx.WorkbookColumn();
sheet.columns[9].width = 130;
sheet.columns[10] = new wjcXlsx.WorkbookColumn();
sheet.columns[10].width = stdNumWidth;
//============= Report header - Employee data =========================
rows[0] = new wjcXlsx.WorkbookRow();
rows[0].cells[8] = new wjcXlsx.WorkbookCell();
rows[0].cells[8].colSpan = 3;
rows[0].cells[8].value = 'For Office Use Only';
rows[0].cells[8].style = new wjcXlsx.WorkbookStyle();
rows[0].cells[8].style.basedOn = highlightedValueStyle;
rows[0].cells[8].style.font = new wjcXlsx.WorkbookFont();
rows[0].cells[8].style.font.italic = true;
rows[1] = new wjcXlsx.WorkbookRow();
rows[1].height = 45;
rows[1].cells[1] = new wjcXlsx.WorkbookCell();
rows[1].cells[1].value = 'Expense Report';
rows[1].cells[1].link = 'A1:B1';
rows[1].cells[1].colSpan = 3;
rows[1].cells[1].style = new wjcXlsx.WorkbookStyle();
rows[1].cells[1].style.basedOn = accentCaptionStyle;
rows[1].cells[1].style.font = new wjcXlsx.WorkbookFont();
rows[1].cells[1].style.font.size = 32;
rows[1].cells[1].style.font.bold = true;
rows[2] = new wjcXlsx.WorkbookRow();
rows[2].cells[1] = new wjcXlsx.WorkbookCell();
rows[2].cells[1].value = 'PURPOSE:';
rows[2].cells[1].style = accentCaptionStyle;
rows[2].cells[2] = new wjcXlsx.WorkbookCell();
rows[2].cells[2].value = empl.Purpose;
rows[2].cells[5] = new wjcXlsx.WorkbookCell();
rows[2].cells[5].value = 'Attachment:';
rows[2].cells[5].style = accentCaptionStyle;
rows[2].cells[6] = new wjcXlsx.WorkbookCell();
rows[2].cells[6].value = empl.Attachment;
rows[5] = new wjcXlsx.WorkbookRow();
rows[5].cells[1] = new wjcXlsx.WorkbookCell();
rows[5].cells[1].value = 'EMPLOYEE IMFORMATION:';
rows[5].cells[1].style = accentCaptionStyle;
rows[5].cells[1].colSpan = 2;
rows[6] = new wjcXlsx.WorkbookRow();
rows[6].cells[1] = new wjcXlsx.WorkbookCell();
rows[6].cells[1].value = 'Name';
rows[6].cells[1].link = 'https://cn.bing.com/';
rows[6].cells[1].style = simpleCaptionStyle;
rows[6].cells[2] = new wjcXlsx.WorkbookCell();
rows[6].cells[2].value = empl.Name;
rows[6].cells[5] = new wjcXlsx.WorkbookCell();
rows[6].cells[5].value = 'Position';
rows[6].cells[5].style = simpleCaptionStyle;
rows[6].cells[6] = new wjcXlsx.WorkbookCell();
rows[6].cells[6].value = empl.Position;
rows[6].cells[9] = new wjcXlsx.WorkbookCell();
rows[6].cells[9].value = 'SSN';
rows[6].cells[9].style = simpleCaptionStyle;
rows[6].cells[10] = new wjcXlsx.WorkbookCell();
rows[6].cells[10].value = empl.SSN;
rows[7] = new wjcXlsx.WorkbookRow();
rows[7].cells[1] = new wjcXlsx.WorkbookCell();
rows[7].cells[1].value = 'Department';
rows[7].cells[1].style = simpleCaptionStyle;
rows[7].cells[2] = new wjcXlsx.WorkbookCell();
rows[7].cells[2].value = empl.Department;
rows[7].cells[5] = new wjcXlsx.WorkbookCell();
rows[7].cells[5].value = 'Manager';
rows[7].cells[5].style = simpleCaptionStyle;
rows[7].cells[6] = new wjcXlsx.WorkbookCell();
rows[7].cells[6].value = empl.Manager;
rows[7].cells[9] = new wjcXlsx.WorkbookCell();
rows[7].cells[9].value = 'Employee ID';
rows[7].cells[9].style = simpleCaptionStyle;
rows[7].cells[10] = new wjcXlsx.WorkbookCell();
rows[7].cells[10].value = empl.Id;
//================ Expense items table ==========================
// Table header
rows[9] = new wjcXlsx.WorkbookRow();
rows[9].style = new wjcXlsx.WorkbookStyle();
rows[9].style.hAlign = wjcXlsx.HAlign.Center;
rows[9].cells[1] = new wjcXlsx.WorkbookCell();
rows[9].cells[1].value = 'Date';
rows[9].cells[1].style = tableHeaderStyle;
rows[9].cells[2] = new wjcXlsx.WorkbookCell();
rows[9].cells[2].value = 'Decsription';
rows[9].cells[2].style = tableHeaderStyle;
rows[9].cells[3] = new wjcXlsx.WorkbookCell();
rows[9].cells[3].value = 'Hotel';
rows[9].cells[3].style = tableHeaderStyle;
rows[9].cells[4] = new wjcXlsx.WorkbookCell();
rows[9].cells[4].value = 'Transport';
rows[9].cells[4].style = tableHeaderStyle;
rows[9].cells[5] = new wjcXlsx.WorkbookCell();
rows[9].cells[5].value = 'Fuel';
rows[9].cells[5].style = tableHeaderStyle;
rows[9].cells[6] = new wjcXlsx.WorkbookCell();
rows[9].cells[6].value = 'Meal';
rows[9].cells[6].style = tableHeaderStyle;
rows[9].cells[7] = new wjcXlsx.WorkbookCell();
rows[9].cells[7].value = 'Misc';
rows[9].cells[7].style = tableHeaderStyle;
rows[9].cells[8] = new wjcXlsx.WorkbookCell();
rows[9].cells[8].value = 'Parking (per hour)';
rows[9].cells[8].style = tableHeaderStyle;
rows[9].cells[9] = new wjcXlsx.WorkbookCell();
rows[9].cells[9].value = 'Parking (hours)';
rows[9].cells[9].style = tableHeaderStyle;
rows[9].cells[10] = new wjcXlsx.WorkbookCell();
rows[9].cells[10].value = 'Total';
rows[9].cells[10].style = tableHeaderStyle;
// Table items
var expenses = <any[]>empl.Expenses,
firstIdx = 10,
totalIdx = firstIdx + expenses.length;
for (var i = 0; i < expenses.length; i++) {
var curExpense = expenses[i],
rowIdx = firstIdx + i;
rows[rowIdx] = new wjcXlsx.WorkbookRow();
rows[rowIdx].cells[1] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[1].value = curExpense.Date;
rows[rowIdx].cells[1].style = tableDateStyle;
rows[rowIdx].cells[2] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[2].value = curExpense.Decsription;
rows[rowIdx].cells[2].style = tableCurrencyStyle;
rows[rowIdx].cells[3] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[3].value = curExpense.Hotel;
rows[rowIdx].cells[3].style = tableCurrencyStyle;
rows[rowIdx].cells[4] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[4].value = curExpense.Transport;
rows[rowIdx].cells[4].style = tableCurrencyStyle;
rows[rowIdx].cells[5] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[5].value = curExpense.Fuel;
rows[rowIdx].cells[5].style = tableCurrencyStyle;
rows[rowIdx].cells[6] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[6].value = curExpense.Meal;
rows[rowIdx].cells[6].style = tableCurrencyStyle;
rows[rowIdx].cells[7] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[7].value = curExpense.Misc;
rows[rowIdx].cells[7].style = tableCurrencyStyle;
rows[rowIdx].cells[8] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[8].value = curExpense.ParkingRate;
rows[rowIdx].cells[8].style = tableCurrencyStyle;
rows[rowIdx].cells[9] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[9].value = curExpense.ParkingHours;
rows[rowIdx].cells[9].style = tableIntegerStyle;
rows[rowIdx].cells[10] = new wjcXlsx.WorkbookCell();
rows[rowIdx].cells[10].formula =
'SUM(' +
wjcXlsx.Workbook.xlsxAddress(rowIdx, 3) +
':' +
wjcXlsx.Workbook.xlsxAddress(rowIdx, 7) +
')+' +
wjcXlsx.Workbook.xlsxAddress(rowIdx, 8) +
'*' +
wjcXlsx.Workbook.xlsxAddress(rowIdx, 9);
rows[rowIdx].cells[10].style = tableCurrencyStyle;
}
// Totals row
var totalColumnIndexes = [3, 4, 5, 6, 7, 10];
rows[totalIdx] = new wjcXlsx.WorkbookRow();
rows[totalIdx].cells[1] = new wjcXlsx.WorkbookCell();
rows[totalIdx].cells[1].value = 'Total';
rows[totalIdx].cells[1].style = tableHeaderStyle;
for (var ti in totalColumnIndexes) {
var ci = totalColumnIndexes[ti];
rows[totalIdx].cells[ci] = new wjcXlsx.WorkbookCell();
rows[totalIdx].cells[ci].formula =
'sum(' +
wjcXlsx.Workbook.xlsxAddress(firstIdx, ci) +
':' +
wjcXlsx.Workbook.xlsxAddress(totalIdx - 1, ci) +
')';
rows[totalIdx].cells[ci].style = tableFooterCurrencyStyle;
}
rows[totalIdx].cells[8] = new wjcXlsx.WorkbookCell();
rows[totalIdx].cells[8].formula =
'SUMPRODUCT(' +
wjcXlsx.Workbook.xlsxAddress(firstIdx, 7) +
':' +
wjcXlsx.Workbook.xlsxAddress(totalIdx - 1, 7) +
',' +
wjcXlsx.Workbook.xlsxAddress(firstIdx, 8) +
':' +
wjcXlsx.Workbook.xlsxAddress(totalIdx - 1, 8) +
')';
rows[totalIdx].cells[8].colSpan = 2;
rows[totalIdx].cells[8].style = tableFooterCurrencyStyle;
rows[totalIdx].cells[2] = new wjcXlsx.WorkbookCell();
rows[totalIdx].cells[2].style = tableHeaderStyle;
// From/To dates in header, via MAX/MIN formulas on Date field
rows[2].cells[8] = new wjcXlsx.WorkbookCell();
rows[2].cells[8].value = 'PAY PERIOD:';
rows[2].cells[8].style = accentCaptionStyle;
rows[2].cells[9] = new wjcXlsx.WorkbookCell();
rows[2].cells[9].value = 'From';
rows[2].cells[9].style = simpleCaptionStyle;
var datesRange =
wjcXlsx.Workbook.xlsxAddress(firstIdx, 1, true) + ':' + wjcXlsx.Workbook.xlsxAddress(totalIdx - 1, 1, true);
rows[2].cells[10] = new wjcXlsx.WorkbookCell();
rows[2].cells[10].formula = 'MIN(' + datesRange + ')';
rows[2].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[2].cells[10].style.format = dateFormat;
rows[3] = new wjcXlsx.WorkbookRow();
rows[3].cells[9] = new wjcXlsx.WorkbookCell();
rows[3].cells[9].value = 'To';
rows[3].cells[9].style = simpleCaptionStyle;
rows[3].cells[10] = new wjcXlsx.WorkbookCell();
rows[3].cells[10].formula = 'MAX(' + datesRange + ')';
rows[3].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[3].cells[10].style.format = dateFormat;
//============ Report footer - totals and misc fields
var footerIdx = totalIdx + 1;
rows[footerIdx] = new wjcXlsx.WorkbookRow();
rows[footerIdx].cells[9] = new wjcXlsx.WorkbookCell();
rows[footerIdx].cells[9].value = 'Subtotal';
rows[footerIdx].cells[9].style = totalCaptionStyle;
rows[footerIdx].cells[10] = new wjcXlsx.WorkbookCell();
rows[footerIdx].cells[10].formula =
wjcXlsx.Workbook.xlsxAddress(footerIdx + 2, 10) + '-' + wjcXlsx.Workbook.xlsxAddress(footerIdx + 1, 10);
rows[footerIdx].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[footerIdx].cells[10].style.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
rows[footerIdx + 1] = new wjcXlsx.WorkbookRow();
rows[footerIdx + 1].cells[9] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 1].cells[9].value = 'Cash Advance';
rows[footerIdx + 1].cells[9].style = totalCaptionStyle;
rows[footerIdx + 1].cells[10] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 1].cells[10].value = empl.Advance;
rows[footerIdx + 1].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[footerIdx + 1].cells[10].style.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
rows[footerIdx + 2] = new wjcXlsx.WorkbookRow();
rows[footerIdx + 2].cells[9] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 2].cells[9].value = 'Total';
rows[footerIdx + 2].cells[9].style = totalCaptionStyle;
rows[footerIdx + 2].cells[10] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 2].cells[10].formula = wjcXlsx.Workbook.xlsxAddress(totalIdx, 10);
rows[footerIdx + 2].cells[10].style = new wjcXlsx.WorkbookStyle();
rows[footerIdx + 2].cells[10].style.format = wjcXlsx.Workbook.toXlsxNumberFormat('c2');
rows[footerIdx + 3] = new wjcXlsx.WorkbookRow();
rows[footerIdx + 3].cells[1] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 3].cells[1].value = 'APPROVED:';
rows[footerIdx + 3].cells[1].style = accentCaptionStyle;
rows[footerIdx + 3].cells[4] = new wjcXlsx.WorkbookCell();
rows[footerIdx + 3].cells[4].value = 'NOTES:';
rows[footerIdx + 3].cells[4].style = accentCaptionStyle;
}
return book;
}
}
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Expense Report Export</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="https://cdn.jsdelivr.net/npm/core-js/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<div class="row">
<button (click)="saveExpenses()" class="btn btn-default">Save Report</button>
</div>
</div>
import { Injectable } from '@angular/core';
@Injectable()
export class DataService {
getEmployeesWithExpences() {
return [
{
Id: 'E892659',
Name: 'Robert King',
Department: 'Sales',
Position: 'Sales Representative',
SSN: 'A37830',
Manager: 'Andrew Fuller',
Purpose: 'On business',
Attachment: true,
Advance: 1000,
Expenses: this._getExpenseItems()
},
{
Id: 'E3667093',
Name: 'John Taylor',
Department: 'Sales',
Position: 'Sales Representative',
SSN: 'A83745',
Manager: 'Andrew Fuller',
Purpose: 'On business',
Attachment: false,
Advance: 800,
Expenses: this._getExpenseItems()
},
{
Id: 'E294989',
Name: 'Gregory Allen',
Department: 'Sales',
Position: 'Sales Representative',
SSN: 'A23927',
Manager: 'Andrew Fuller',
Purpose: 'On business',
Attachment: true,
Advance: 1200,
Expenses: this._getExpenseItems()
},
];
}
private _getExpenseItems() {
let count = 5 + Math.round(Math.random() * 5),
ret = [],
msPerDay = 1000 * 24 * 60 * 60,
curDate = Date.now() - 60 * msPerDay;
for (let i = 0; i < count; i++) {
ret.push(
{
Date: new Date(curDate),
Decsription: 'Customer visit',
Hotel: 30 + Math.random() * 200,
Transport: 10 + Math.random() * 150,
Fuel: Math.random() * 50,
Meal: 30 + Math.random() * 170,
ParkingRate: 3.75,
ParkingHours: 8 + Math.round(Math.random() * 16),
Misc: Math.random() * 220
});
curDate += msPerDay * Math.round(Math.random() * 4);
}
return ret;
}
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
target: 'ES2022',
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
typescript: {
exports: 'ts',
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm',
},
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/',
'agpcdn:': 'https://cdn.jsdelivr.net/npm/'
},
packageConfigPaths: ['/node_modules/*/package.json', '/node_modules/@angular/*/package.json', '/node_modules/@mescius/*/package.json'],
map: {
'core-js': 'agpcdn:core-js@2.6.12/client/shim.min.js',
'typescript': 'agpcdn:typescript@5.9.3/lib/typescript.min.js',
rxjs: 'agpcdn:rxjs@7.8.1/dist/bundles/rxjs.umd.min.js',
'systemjs-plugin-css': 'agpcdn:systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.angular2.chart.analytics': 'cdn:@mescius/wijmo.angular2.chart.analytics/index.js',
'@mescius/wijmo.angular2.chart.animation': 'cdn:@mescius/wijmo.angular2.chart.animation/index.js',
'@mescius/wijmo.angular2.chart.annotation': 'cdn:@mescius/wijmo.angular2.chart.annotation/index.js',
'@mescius/wijmo.angular2.chart.finance.analytics': 'cdn:@mescius/wijmo.angular2.chart.finance.analytics/index.js',
'@mescius/wijmo.angular2.chart.finance': 'cdn:@mescius/wijmo.angular2.chart.finance/index.js',
'@mescius/wijmo.angular2.chart.hierarchical': 'cdn:@mescius/wijmo.angular2.chart.hierarchical/index.js',
'@mescius/wijmo.angular2.chart.interaction': 'cdn:@mescius/wijmo.angular2.chart.interaction/index.js',
'@mescius/wijmo.angular2.chart.radar': 'cdn:@mescius/wijmo.angular2.chart.radar/index.js',
'@mescius/wijmo.angular2.chart.map': 'cdn:@mescius/wijmo.angular2.chart.map/index.js',
'@mescius/wijmo.angular2.chart': 'cdn:@mescius/wijmo.angular2.chart/index.js',
'@mescius/wijmo.angular2.core': 'cdn:@mescius/wijmo.angular2.core/index.js',
'@mescius/wijmo.angular2.gauge': 'cdn:@mescius/wijmo.angular2.gauge/index.js',
'@mescius/wijmo.angular2.grid.detail': 'cdn:@mescius/wijmo.angular2.grid.detail/index.js',
'@mescius/wijmo.angular2.grid.filter': 'cdn:@mescius/wijmo.angular2.grid.filter/index.js',
'@mescius/wijmo.angular2.grid.grouppanel': 'cdn:@mescius/wijmo.angular2.grid.grouppanel/index.js',
'@mescius/wijmo.angular2.grid.search': 'cdn:@mescius/wijmo.angular2.grid.search/index.js',
'@mescius/wijmo.angular2.grid.multirow': 'cdn:@mescius/wijmo.angular2.grid.multirow/index.js',
'@mescius/wijmo.angular2.grid.sheet': 'cdn:@mescius/wijmo.angular2.grid.sheet/index.js',
'@mescius/wijmo.angular2.grid.transposed': 'cdn:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'cdn:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
'@mescius/wijmo.angular2.grid': 'cdn:@mescius/wijmo.angular2.grid/index.js',
'@mescius/wijmo.angular2.input': 'cdn:@mescius/wijmo.angular2.input/index.js',
'@mescius/wijmo.angular2.olap': 'cdn:@mescius/wijmo.angular2.olap/index.js',
'@mescius/wijmo.angular2.viewer': 'cdn:@mescius/wijmo.angular2.viewer/index.js',
'@mescius/wijmo.angular2.nav': 'cdn:@mescius/wijmo.angular2.nav/index.js',
'@mescius/wijmo.angular2.directivebase': 'cdn:@mescius/wijmo.angular2.directivebase/index.js',
'@mescius/wijmo.angular2.barcode.common': 'cdn:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'cdn:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'cdn:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'agpcdn:jszip@3.10.1/dist/jszip.min.js',
'@angular/core': 'pcdn:@angular/core@21.1.0/fesm2022/core.mjs',
'@angular/core/primitives/di': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-di.mjs',
'@angular/core/primitives/signals': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-signals.mjs',
'@angular/core/primitives/event-dispatch': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-event-dispatch.mjs',
'@angular/common': 'pcdn:@angular/common@21.1.0/fesm2022/common.mjs',
'@angular/common/http': 'pcdn:@angular/common@21.1.0/fesm2022/http.mjs',
'@angular/compiler': 'pcdn:@angular/compiler@21.1.0/fesm2022/compiler.mjs',
'@angular/platform-browser': 'pcdn:@angular/platform-browser@21.1.0/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'pcdn:@angular/platform-browser-dynamic@21.1.0/fesm2022/platform-browser-dynamic.mjs',
'@angular/router': 'pcdn:@angular/router@21.1.0/fesm2022/router.mjs',
'@angular/forms': 'pcdn:@angular/forms@21.1.0/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
'./src': {
defaultExtension: 'ts',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);